Add [v]iew patch in git-am interactive.
[git/git.git] / git-am.sh
CommitLineData
d1c5f2a4
JH
1#!/bin/sh
2#
3#
4. git-sh-setup || die "Not a git archive"
5
6files=$(git-diff-index --cached --name-only HEAD) || exit
7if [ "$files" ]; then
8 echo "Dirty index: cannot apply patches (dirty: $files)" >&2
9 exit 1
10fi
11
12usage () {
13 echo >&2 "usage: $0 [--signoff] [--dotest=<dir>] [--utf8] [--3way] <mbox>"
14 echo >&2 " or, when resuming"
15 echo >&2 " $0 [--skip]"
16 exit 1;
17}
18
19stop_here () {
20 echo "$1" >"$dotest/next"
21 exit 1
22}
23
24go_next () {
25 rm -f "$dotest/$msgnum" "$dotest/msg" "$dotest/msg-clean" \
26 "$dotest/patch" "$dotest/info"
27 echo "$next" >"$dotest/next"
28 this=$next
29}
30
31fall_back_3way () {
32 O_OBJECT=`cd "$GIT_OBJECT_DIRECTORY" && pwd`
33
34 rm -fr "$dotest"/patch-merge-*
35 mkdir "$dotest/patch-merge-tmp-dir"
36
37 # First see if the patch records the index info that we can use.
22943f1a 38 if git-apply -z --index-info "$dotest/patch" \
d1c5f2a4
JH
39 >"$dotest/patch-merge-index-info" 2>/dev/null &&
40 GIT_INDEX_FILE="$dotest/patch-merge-tmp-index" \
22943f1a 41 git-update-index -z --index-info <"$dotest/patch-merge-index-info" &&
d1c5f2a4
JH
42 GIT_INDEX_FILE="$dotest/patch-merge-tmp-index" \
43 git-write-tree >"$dotest/patch-merge-base+" &&
44 # index has the base tree now.
45 (
46 cd "$dotest/patch-merge-tmp-dir" &&
47 GIT_INDEX_FILE="../patch-merge-tmp-index" \
48 GIT_OBJECT_DIRECTORY="$O_OBJECT" \
49 git-apply --index <../patch
50 )
51 then
52 echo Using index info to reconstruct a base tree...
53 mv "$dotest/patch-merge-base+" "$dotest/patch-merge-base"
54 mv "$dotest/patch-merge-tmp-index" "$dotest/patch-merge-index"
55 else
56 # Otherwise, try nearby trees that can be used to apply the
57 # patch.
58 (
59 N=10
60
61 # Hoping the patch is against our recent commits...
62 git-rev-list --max-count=$N HEAD
63
64 # or hoping the patch is against known tags...
65 git-ls-remote --tags .
66 ) |
67 while read base junk
68 do
69 # See if we have it as a tree...
70 git-cat-file tree "$base" >/dev/null 2>&1 || continue
71
72 rm -fr "$dotest"/patch-merge-* &&
73 mkdir "$dotest/patch-merge-tmp-dir" || break
74 (
75 cd "$dotest/patch-merge-tmp-dir" &&
76 GIT_INDEX_FILE=../patch-merge-tmp-index &&
77 GIT_OBJECT_DIRECTORY="$O_OBJECT" &&
78 export GIT_INDEX_FILE GIT_OBJECT_DIRECTORY &&
79 git-read-tree "$base" &&
80 git-apply --index &&
81 mv ../patch-merge-tmp-index ../patch-merge-index &&
82 echo "$base" >../patch-merge-base
83 ) <"$dotest/patch" 2>/dev/null && break
84 done
85 fi
86
87 test -f "$dotest/patch-merge-index" &&
88 his_tree=$(GIT_INDEX_FILE="$dotest/patch-merge-index" git-write-tree) &&
89 orig_tree=$(cat "$dotest/patch-merge-base") &&
90 rm -fr "$dotest"/patch-merge-* || exit 1
91
92 echo Falling back to patching base and 3-way merge...
93
94 # This is not so wrong. Depending on which base we picked,
95 # orig_tree may be wildly different from ours, but his_tree
96 # has the same set of wildly different changes in parts the
97 # patch did not touch, so resolve ends up cancelling them,
98 # saying that we reverted all those changes.
99
100 git-merge-resolve $orig_tree -- HEAD $his_tree || {
101 echo Failed to merge in the changes.
102 exit 1
103 }
104}
105
106prec=4
107dotest=.dotest sign= utf8= keep= skip= interactive=
108
109while case "$#" in 0) break;; esac
110do
111 case "$1" in
112 -d=*|--d=*|--do=*|--dot=*|--dote=*|--dotes=*|--dotest=*)
113 dotest=`expr "$1" : '-[^=]*=\(.*\)'`; shift ;;
114 -d|--d|--do|--dot|--dote|--dotes|--dotest)
115 case "$#" in 1) usage ;; esac; shift
116 dotest="$1"; shift;;
117
118 -i|--i|--in|--int|--inte|--inter|--intera|--interac|--interact|\
119 --interacti|--interactiv|--interactive)
120 interactive=t; shift ;;
121
122 -3|--3|--3w|--3wa|--3way)
123 threeway=t; shift ;;
124 -s|--s|--si|--sig|--sign|--signo|--signof|--signoff)
125 sign=t; shift ;;
126 -u|--u|--ut|--utf|--utf8)
127 utf8=t; shift ;;
128 -k|--k|--ke|--kee|--keep)
129 keep=t; shift ;;
130
131 --sk|--ski|--skip)
132 skip=t; shift ;;
133
134 --)
135 shift; break ;;
136 -*)
137 usage ;;
138 *)
139 break ;;
140 esac
141done
142
143if test -d "$dotest" &&
144 last=$(cat "$dotest/last") &&
145 next=$(cat "$dotest/next") &&
146 test $# != 0 &&
147 test "$next" -gt "$last"
148then
149 rm -fr "$dotest"
150fi
151
152if test -d "$dotest"
153then
154 test ",$#," = ",0," ||
155 die "previous dotest directory $dotest still exists but mbox given."
271440e3 156 resume=yes
d1c5f2a4
JH
157else
158 # Make sure we are not given --skip
159 test ",$skip," = ,, ||
160 die "we are not resuming."
161
162 # Start afresh.
163 mkdir -p "$dotest" || exit
164
165 # cat does the right thing for us, including '-' to mean
166 # standard input.
167 cat "$@" |
168 git-mailsplit -d$prec "$dotest/" >"$dotest/last" || {
169 rm -fr "$dotest"
170 exit 1
171 }
172
173 echo "$sign" >"$dotest/sign"
174 echo "$utf8" >"$dotest/utf8"
175 echo "$keep" >"$dotest/keep"
d1c5f2a4
JH
176 echo 1 >"$dotest/next"
177fi
178
179if test "$(cat "$dotest/utf8")" = t
180then
181 utf8=-u
182fi
183if test "$(cat "$dotest/keep")" = t
184then
185 keep=-k
186fi
187if test "$(cat "$dotest/sign")" = t
188then
189 SIGNOFF=`git-var GIT_COMMITTER_IDENT | sed -e '
190 s/>.*/>/
191 s/^/Signed-off-by: /'
192 `
193else
194 SIGNOFF=
195fi
d1c5f2a4
JH
196
197last=`cat "$dotest/last"`
198this=`cat "$dotest/next"`
199if test "$skip" = t
200then
201 this=`expr "$this" + 1`
202fi
203
204if test "$this" -gt "$last"
205then
206 echo Nothing to do.
207 rm -fr "$dotest"
208 exit
209fi
210
211while test "$this" -le "$last"
212do
213 msgnum=`printf "%0${prec}d" $this`
214 next=`expr "$this" + 1`
215 test -f "$dotest/$msgnum" || {
216 go_next
217 continue
218 }
271440e3
JH
219 case "$resume" in
220 '')
221 git-mailinfo $keep $utf8 "$dotest/msg" "$dotest/patch" \
222 <"$dotest/$msgnum" >"$dotest/info" ||
223 stop_here $this
224 git-stripspace < "$dotest/msg" > "$dotest/msg-clean"
225 ;;
226 esac
227 resume=
d1c5f2a4
JH
228
229 GIT_AUTHOR_NAME="$(sed -n '/^Author/ s/Author: //p' "$dotest/info")"
230 GIT_AUTHOR_EMAIL="$(sed -n '/^Email/ s/Email: //p' "$dotest/info")"
231 GIT_AUTHOR_DATE="$(sed -n '/^Date/ s/Date: //p' "$dotest/info")"
232 SUBJECT="$(sed -n '/^Subject/ s/Subject: //p' "$dotest/info")"
2c674191 233 export GIT_AUTHOR_NAME GIT_AUTHOR_EMAIL GIT_AUTHOR_DATE
d1c5f2a4
JH
234
235 case "$keep_subject" in -k) SUBJECT="[PATCH] $SUBJECT" ;; esac
236 if test '' != "$SIGNOFF"
237 then
238 LAST_SIGNED_OFF_BY=`
239 sed -ne '/^Signed-off-by: /p' "$dotest/msg-clean" |
240 tail -n 1
241 `
242 ADD_SIGNOFF=$(test "$LAST_SIGNED_OFF_BY" = "$SIGNOFF" || {
243 test '' = "$LAST_SIGNED_OFF_BY" && echo
244 echo "$SIGNOFF"
245 })
246 else
247 ADD_SIGNOFF=
248 fi
249 {
250 echo "$SUBJECT"
251 if test -s "$dotest/msg-clean"
252 then
253 echo
254 cat "$dotest/msg-clean"
255 fi
256 if test '' != "$ADD_SIGNOFF"
257 then
258 echo "$ADD_SIGNOFF"
259 fi
260 } >"$dotest/final-commit"
261
262 if test "$interactive" = t
263 then
a1451104
JH
264 test -t 0 ||
265 die "cannot be interactive without stdin connected to a terminal."
d1c5f2a4
JH
266 action=again
267 while test "$action" = again
268 do
269 echo "Commit Body is:"
270 echo "--------------------------"
271 cat "$dotest/final-commit"
272 echo "--------------------------"
f89ad67f 273 echo -n "Apply? [y]es/[n]o/[e]dit/[v]iew patch/[a]ccept all "
d1c5f2a4
JH
274 read reply
275 case "$reply" in
f89ad67f
JH
276 [yY]*) action=yes ;;
277 [aA]*) action=yes interactive= ;;
278 [nN]*) action=skip ;;
279 [eE]*) "${VISUAL:-${EDITOR:-vi}}" "$dotest/final-commit"
d1c5f2a4 280 action=again ;;
f89ad67f
JH
281 [vV]*) action=again
282 LESS=-S ${PAGER:-less} "$dotest/patch" ;;
283 *) action=again ;;
d1c5f2a4
JH
284 esac
285 done
286 else
287 action=yes
288 fi
289
290 if test $action = skip
291 then
292 go_next
293 continue
294 fi
295
296 if test -x "$GIT_DIR"/hooks/applypatch-msg
297 then
298 "$GIT_DIR"/hooks/applypatch-msg "$dotest/final-commit" ||
299 stop_here $this
300 fi
301
302 echo
303 echo "Applying '$SUBJECT'"
304 echo
305
306 git-apply --index "$dotest/patch"; apply_status=$?
307 if test $apply_status = 1 && test "$threeway" = t
308 then
73319032 309 if (fall_back_3way)
d1c5f2a4 310 then
73319032
JH
311 # Applying the patch to an earlier tree and merging the
312 # result may have produced the same tree as ours.
313 changed="$(git-diff-index --cached --name-only -z HEAD)"
314 if test '' = "$changed"
315 then
316 echo No changes -- Patch already applied.
317 go_next
318 continue
319 fi
320 # clear apply_status -- we have successfully merged.
321 apply_status=0
d1c5f2a4
JH
322 fi
323 fi
324 if test $apply_status != 0
325 then
326 echo Patch failed at $msgnum.
327 stop_here $this
328 fi
329
330 if test -x "$GIT_DIR"/hooks/pre-applypatch
331 then
332 "$GIT_DIR"/hooks/pre-applypatch || stop_here $this
333 fi
334
335 tree=$(git-write-tree) &&
336 echo Wrote tree $tree &&
337 parent=$(git-rev-parse --verify HEAD) &&
338 commit=$(git-commit-tree $tree -p $parent <"$dotest/final-commit") &&
339 echo Committed: $commit &&
340 git-update-ref HEAD $commit $parent ||
341 stop_here $this
342
343 if test -x "$GIT_DIR"/hooks/post-applypatch
344 then
345 "$GIT_DIR"/hooks/post-applypatch
346 fi
347
348 go_next
349done
350
351rm -fr "$dotest"